#include "aux/assert.h"
#include "aux/queue.h"
#include "aux/success_or_die.h"
#include "aux/testsome.h"

#include "gaspi/slice.h"

#include "constant.h"
#include "data.h"
#include "topology.h"

void init_slices (slice *ssl)
{
  for (int l = 0; l < NTHREADS; ++l)
  {
    ssl[l].stage = 0;
    ssl[l].index = l+1;
    ssl[l].left = ssl + ((l + NTHREADS - 1) % NTHREADS);
    ssl[l].next = ssl + ((l + NTHREADS + 1) % NTHREADS);
    omp_init_lock (&ssl[l].lock);
  }

}


void handle_slice( slice *sl, double* array
		   , gaspi_notification_id_t* left_data_available
		   , gaspi_notification_id_t* right_data_available
		   , gaspi_segment_id_t segment_id
		   , gaspi_queue_id_t queue_id
		   , int num
		   )
{

  const int right_halo  = NTHREADS+1;
  const int left_halo   = 0;

  ASSERT (sl->stage < num);

  int const new_buffer_id = (sl->stage + NWAY + 1 ) % NWAY;;
  int const old_buffer_id = (sl->stage + NWAY) % NWAY;

  /*
    TODO
    ====

    Implement the check of preconditions and the data
    exchange

    You might use
    	test_or_die

   */

  if (sl->index == left_halo + 1)
  {

  }
  if (sl->index == right_halo - 1)
  {

  }
  if ((sl->index > left_halo + 1) && (sl->index < right_halo - 1))
  {

  }

  data_compute (array, new_buffer_id, old_buffer_id, sl->index);

  if (sl->index == left_halo + 1)
  {

  }
  if (sl->index == right_halo - 1)
  {

  }

  ++sl->stage;
}
